---
title: Bitwise NOT (~)
slug: Web/JavaScript/Reference/Operators/Bitwise_NOT
tags:
  - Bitwise operator
  - JavaScript
  - Language feature
  - Operator
  - Reference
---
<div>{{jsSidebar("Operators")}}</div>

<p>The bitwise NOT operator (<code>~</code>) inverts the bits of its operand.</p>

<div>{{EmbedInteractiveExample("pages/js/expressions-bitwise-not.html")}}</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox notranslate"><code><var>~a</var></code>
</pre>

<h2 id="Description">Description</h2>

<p>The operands are converted to 32-bit integers and expressed by a series of bits (zeroes and ones). Numbers with more than 32 bits get their most significant bits discarded. For example, the following integer with more than 32 bits will be converted to a 32 bit integer:</p>

<pre class="brush: js notranslate">Before: 11100110111110100000000000000110000000000001
After:              10100000000000000110000000000001</pre>

<p>Each bit in the first operand is paired with the corresponding bit in the second operand: <em>first bit</em> to <em>first bit</em>, <em>second bit</em> to <em>second bit</em>, and so on.</p>

<p>The operator is applied to each pair of bits, and the result is constructed bitwise.</p>

<p>The truth table for the <code>NOT</code> operation is:</p>

<table class="standard-table">
 <thead>
  <tr>
   <th class="header" scope="col">a</th>
   <th class="header" scope="col">NOT a</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td>0</td>
   <td>1</td>
  </tr>
  <tr>
   <td>1</td>
   <td>0</td>
  </tr>
 </tbody>
</table>

<pre class="brush: js notranslate"> 9 (base 10) = 00000000000000000000000000001001 (base 2)
               --------------------------------
~9 (base 10) = 11111111111111111111111111110110 (base 2) = -10 (base 10)
</pre>

<p>Bitwise NOTing any number <code>x</code> yields <code>-(x + 1)</code>. For example, <code>~-5</code> yields <code>4</code>.</p>

<p>Note that due to using 32-bit representation for numbers both <code>~-1</code> and <code>~4294967295</code> (2<sup>32</sup>-1) results in <code>0</code>.</p>

<h2 id="Examples">Examples</h2>

<h3 id="Using_bitwise_NOT">Using bitwise NOT</h3>

<pre class="brush: js notranslate">~0;  // -1
~-1; // 0
~1;  // -2
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
  </tr>
  <tr>
   <td>{{SpecName('ESDraft', '#sec-unary-operators', 'Unary NOT expression')}}</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("javascript.operators.bitwise_not")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li><a href="/en-US/docs/Web/JavaScript/Guide/Expressions_and_Operators#Bitwise">Bitwise operators in the JS guide</a></li>
</ul>
